<GoogleSdk {apiKey} on:ready={initialise} />
<input class={styleClass} id="input map" type="text" placeholder={placeholder} aria-label={ariaLabel}  bind:this={search} {disabled} bind:value={viewValue} on:blur={blur} on:keydown={autocompleteKeydown}  />
<script>
  import GoogleSdk from './sdk.svelte'
  import { createEventDispatcher } from 'svelte'
  import Swal from 'sweetalert2';
  export let apiKey = null
  export let ariaLabel = 'location'
  export let placeholder = 'Location'
  export let styleClass = ''
  export let value = null
  export let viewValue = null
  export let options = {}
  let search
  let autocomplete
  let currentPlace
  let disabled = true
  let dropdown
  const dispatch = createEventDispatcher()
  export function clear () {
    value = null
    viewValue = null
    currentPlace = null
    dispatch('clear')
  }
  function dropdownVisible () {
    return document.querySelectorAll('.pac-container')[0].offsetParent !== null
  }
  function autocompleteKeydown (e) {
    if (e.keyCode == 13 && dropdownVisible()) { 
      e.preventDefault()
    }
  }
  function blur () {
    dispatch('blur')
    if (viewValue !== currentPlace) {
      clear()
    }
  }
  function initialise () {
    const google = window['google']
    autocomplete = new google.maps.places.Autocomplete(
      search,
      options
    )
    disabled = false
    autocomplete.addListener('place_changed', () => {
      const place = autocomplete.getPlace()
      if (!place.geometry) {
        return clear()
      }
      const { formatted_address } = place
      value = place
      viewValue = formatted_address
      currentPlace = formatted_address
      dispatch('placeChanged', { place, selectedPrediction: search.value })
    })
    dispatch('ready')
  }
</script>